/*
===========================================================================
Copyright (C) 1999-2005 Id Software, Inc.

This file is part of Quake III Arena source code.

Quake III Arena source code is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Quake III Arena source code is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Foobar; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
===========================================================================
*/
//
/*
=======================================================================

CREDITS

=======================================================================
*/


#include "ui_local.h"


typedef struct
{
	menuframework_s menu;
} creditsmenu_t;

static creditsmenu_t s_credits;


/*
=================
UI_CreditMenu_Key
=================
*/
static sfxHandle_t UI_CreditMenu_Key(int key)
{
	if(key & K_CHAR_FLAG)
	{
		return 0;
	}

	trap_Cmd_ExecuteText(EXEC_APPEND, "quit\n");
	return 0;
}


/*
===============
UI_CreditMenu_Draw
===============
*/
static void UI_CreditMenu_Draw(void)
{
	int             y;

	y = 12;
	UI_DrawProportionalString(320, y, "Credits", UI_CENTER | UI_SMALLFONT, colorRed);

	y += 1.42 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Project Lead:", UI_CENTER | UI_SMALLFONT, colorLtGrey);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Pat 'raynorpat' Raynor", UI_CENTER | UI_SMALLFONT, colorWhite);

	y += 1.42 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Programming:", UI_CENTER | UI_SMALLFONT, colorLtGrey);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Pat 'raynorpat' Raynor", UI_CENTER | UI_SMALLFONT, colorWhite);

	y += 1.42 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Media:", UI_CENTER | UI_SMALLFONT, colorLtGrey);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Pat 'raynorpat' Raynor,", UI_CENTER | UI_SMALLFONT, colorWhite);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Robert 'Tr3B' Beckebans,", UI_CENTER | UI_SMALLFONT, colorWhite);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Saphire Scar Team,", UI_CENTER | UI_SMALLFONT, colorWhite);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Open Arena Team,", UI_CENTER | UI_SMALLFONT, colorWhite);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Chilli Quake XXL Team", UI_CENTER | UI_SMALLFONT, colorWhite);

	y += 1.42 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Level Design:", UI_CENTER | UI_SMALLFONT, colorLtGrey);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Pat 'raynorpat' Raynor", UI_CENTER | UI_SMALLFONT, colorWhite);

	y += 1.42 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "Special Thanks:", UI_CENTER | UI_SMALLFONT, colorLtGrey);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "XreaL Team - xreal.sf.net", UI_CENTER | UI_SMALLFONT, colorWhite);
	y += PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawProportionalString(320, y, "ioquake3 project - ioquake3.org", UI_CENTER | UI_SMALLFONT, colorWhite);

	y += 1.35 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawString(320, y, "Website:   http://evolution.quakedev.com/revolution", UI_CENTER | UI_SMALLFONT, colorBlue);
	y += 1.35 * PROP_HEIGHT * PROP_SMALL_SIZE_SCALE;
	UI_DrawString(320, y, "Quake III Arena(c) 1999-2007, Id Software, Inc.", UI_CENTER | UI_SMALLFONT, colorRed);
	y += SMALLCHAR_HEIGHT;
	UI_DrawString(320, y, "Revolution(c) 2005-2007, Team Evolution and Contributors", UI_CENTER | UI_SMALLFONT, colorRed);
}


/*
===============
UI_CreditMenu
===============
*/
void UI_CreditMenu(void)
{
	memset(&s_credits, 0, sizeof(s_credits));

	s_credits.menu.draw = UI_CreditMenu_Draw;
	s_credits.menu.key = UI_CreditMenu_Key;
	s_credits.menu.fullscreen = qtrue;
	UI_PushMenu(&s_credits.menu);
}
